// Example Patch Source  "delphi-style"
// www.sunshine.2kx.de

// Just a little file patcher. Not too difficult to understand.
// Notice: No backup file of test.exe will be made!
// Questions, ideas etc.? Mail me: Lloret01@gmx.de

program Patcher;

uses
  Windows, Messages,Classes,sysutils;

const
  filename = 'Test.exe';      // which file to patch
  offsets : array[1..2] of DWORD = ($813, $814);  // which offsets
  patchbytes : array[1..2] of byte = ($6F, $76);  // what to write
  oldbytes : array[1..2] of byte = ($69, $66);   // old bytes
  numberpatch : Integer = 2;  // how many bytes to patch

var
  f : file;
  i : Integer;                // loop variable
  buf : array[1..2] of Byte;  // temp var to store bytes from file
{$R *.RES}

begin
 if MessageBoxA(0,'This prog will patch Test.exe! File' +
               'must be in the same folder!', 'Example',
                mb_OkCancel) = IDCANCEL then
    begin
      MessageboxA(0, 'Closing without patching', 'Bye', mb_OK);
      halt;
    end;

  AssignFile(f,filename);
  {$I-}
  reset(F,1);
  {$I+}
  if IOResult <> 0 then              // check if file is there
  begin
    MessageBoxA(0, 'File NOT Found!!', 'Error!', MB_OK);
    exit;
  end;

  If filesize(f) <> 2560 then       // check correct file size
  begin
      if MessageBoxA(0,'Filesize different! Seems not to be the right file!' +
                  #13 + 'Do you really want to go on?','Shit..',
                  mb_okCancel) = IDCANCEL
      then
      begin
        Closefile(f);
        halt;
      end;
    end;

  for i := 1 to numberpatch do     // check if correct bytes are there
  begin
    Seek(f,offsets[i]);
    BlockRead(f, buf[i],1);
    if buf[i] <> oldbytes[i] then
    begin
      if MessageBoxA(0,'Bytes found are not identical to original bytes!' +
                  #13 + 'Do you really want to go on?','Shit..',
                  mb_okCancel) = IDCANCEL
      then
      begin
        Closefile(f);
        halt;
      end;
    end;

  end;


  for i := 1 to numberpatch do   // now patch it!
  begin
    Seek(f,offsets[i]);
    Blockwrite(f,patchbytes[i],1);
  end;
  Closefile(f);
  MessageBoxA(0, 'Everything seemed to work fine!', ':-)', MB_OK);

end.