// Example Patch Source
// www.sunshine.2kx.de

// Notice: No backup of Test.exe will be made!
// Questions, ideas etc.? Mail me: Lloret01@gmx.de

program PatcherApi;

uses
  Windows, Messages;

const
  filename = 'Test.exe';    // which file to patch
  offsets : array[1..2] of DWORD = ($813, $814);  // which offset
  patchbytes : array[1..2] of byte = ($6F, $76); // what to write
  oldbytes : array[1..2] of byte = ($69, $66);   // old bytes
  numberpatch : Integer = 2;  // how many patches


var
  f : THandle;
  i : Integer;
  Written, reada : DWord;
  buf : Byte;  // temp var to store bytes from file



{$R *.RES}

begin
 if MessageBoxA(0,'This prog will patch Test.exe! File' +
               'must be in the same folder!', 'Example',
                mb_OkCancel) = IDCANCEL then
    begin
      MessageboxA(0, 'Closing without patching', 'Bye', mb_OK);
      halt;
    end;

  f := CreateFileA(filename,GENERIC_WRITE or GENERIC_READ,FILE_SHARE_READ,nil,
                        OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL,0);

  if f = INVALID_HANDLE_VALUE then      // if file doesn't exist
  begin
    MessageboxA(0, 'File NOT found! Prog will quit...', 'Bye', mb_OK);
    halt;
  end;

  if GetFileSize(F, nil) <> 2560 then  // different file size?
  begin
    IF MessageboxA(0, 'Different file size! Seems not to be the right file!' + #13 +
               'Do you really want to go on?' , 'Bye', mb_OKCancel) = IDCANCEL
    then
    begin
      CloseHandle(f);
      halt;
    end;
  end;

  for i := 1 to numberpatch do        // Check bytes
  begin
    SetFilePointer(f,offsets[i],nil,FILE_BEGIN);
    ReadFile(f,buf ,1,reada,nil);
    if buf <> oldbytes[i] then
    begin
      IF MessageboxA(0,pchar('Bytes found are not identical to original bytes!' +#13 +
                     'Do you really want to go on?'),'Shit..', mb_okCancel)
                    = IDCANCEL
      
      then
      begin
        CloseHandle(f);
        halt;
      end;
    end;
  end;


  for i := 1 to numberpatch do      // now patch!
  begin
    SetFilePointer(f,offsets[i],nil,FILE_BEGIN);
    WriteFile(f,patchbytes[i],1,written,nil);
  end;
  
  CloseHandle(f);
  MessageBoxA(0, 'Everything seemed to work fine!', ':-)', MB_OK);

end.

